﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

//using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;
//using GL=OpenTK.Graphics.OpenGL.GL;

namespace TKTest {
    public partial class Form1: Form {
        bool m_loaded1=false,m_loaded2=false;
        CGame m_game;
        Scene3D m_scene,m_fig;
        
        public Form1() {
            InitializeComponent();
            m_game=new CGame();
            m_scene=new Scene3D(m_game,0);
            m_fig=new Scene3D(m_game,1);
            UpdateText();
        }

        private void glControl1_Load(object sender,EventArgs e) {
            m_loaded1=true;
            glControl1.MakeCurrent();
            m_scene.InitView(glControl1.Width,glControl1.Height);
        }
        private void glControl2_Load(object sender,EventArgs e) {
            m_loaded2=true;
            glControl2.MakeCurrent();
            m_fig.InitView(glControl2.Width,glControl2.Height);
        }

        object m_lockobj=new object();
        private void glControl1_Paint(object sender,PaintEventArgs e) {
            if(!m_loaded1) return;
            lock(m_lockobj) {
                glControl1.MakeCurrent();
                GL.Clear(ClearBufferMask.ColorBufferBit|ClearBufferMask.DepthBufferBit);
                m_scene.Render();
                glControl1.SwapBuffers();
            }
        }

        private void glControl1_MouseDown(object sender,MouseEventArgs e) {
            m_scene.MouseDown(e.Button==MouseButtons.Left,e.X,e.Y,GetKbdStatus());
        }

        private void glControl1_MouseLeave(object sender,EventArgs e) {
            m_scene.MouseLeave();
        }

        private void glControl1_MouseMove(object sender,MouseEventArgs e) {
            m_scene.MouseMove(e.X,e.Y,GetKbdStatus());
            glControl1.Invalidate();
        }

        private void glControl1_MouseUp(object sender,MouseEventArgs e) {
            m_scene.MouseUp(e.Button==MouseButtons.Left,e.X,e.Y,GetKbdStatus());
            UpdateText();
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

        KButtons GetKbdStatus() {
            KButtons k=KButtons.ZERO;
            if((Control.ModifierKeys & System.Windows.Forms.Keys.Shift)!=0) k|=KButtons.K_SHIFT;
            if((Control.ModifierKeys & System.Windows.Forms.Keys.Control)!=0) k|=KButtons.K_CTRL;
            if((Control.ModifierKeys & System.Windows.Forms.Keys.Alt)!=0) k|=KButtons.K_ALT;
            return k;
        }

        private void glControl1_Resize(object sender,EventArgs e) {
            glControl1.MakeCurrent();
            m_scene.SetSize(glControl1.Width,glControl1.Height);
            glControl1.Invalidate();
        }



        private void glControl2_Paint(object sender,PaintEventArgs e) {
            if(!m_loaded2) return;
            lock(m_lockobj) {
                glControl2.MakeCurrent();
                GL.Clear(ClearBufferMask.ColorBufferBit|ClearBufferMask.DepthBufferBit);
                m_fig.Render();
                glControl2.SwapBuffers();
            }
        }

        private void glControl2_MouseDown(object sender,MouseEventArgs e) {
            m_fig.MouseDown(e.Button==MouseButtons.Left,e.X,e.Y,GetKbdStatus());
        }

        private void glControl2_MouseLeave(object sender,EventArgs e) {
            m_fig.MouseLeave();
        }

        private void glControl2_MouseMove(object sender,MouseEventArgs e) {
            m_fig.MouseMove(e.X,e.Y,GetKbdStatus());
            glControl2.Invalidate();
        }

        private void glControl2_MouseUp(object sender,MouseEventArgs e) {
            m_fig.MouseUp(e.Button==MouseButtons.Left,e.X,e.Y,GetKbdStatus());
            UpdateText();
            glControl2.Invalidate();
        }

        private void glControl2_Resize(object sender,EventArgs e) {
            glControl2.MakeCurrent();
            m_fig.SetSize(glControl2.Width,glControl2.Height);
            glControl2.Invalidate();

        }

        private void m_Start_Click(object sender,EventArgs e) {
            m_game.Start((int)m_nudNPl.Value,(int)m_nudTiles.Value);
            UpdateText();
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

        private void UpdateText() {
            m_lblFree1.Text=m_game.NFree(1).ToString();
            m_lblFree2.Text=m_game.NFree(2).ToString();
            m_lblFree3.Text=m_game.NFree(3).ToString();
            m_lblFree4.Text=m_game.NFree(4).ToString();
            m_lblFree5.Text=m_game.NFree(5).ToString();
            m_lblScore1.Text=m_game.NScore(1).ToString();
            m_lblScore2.Text=m_game.NScore(2).ToString();
            m_lblScore3.Text=m_game.NScore(3).ToString();
            m_lblScore4.Text=m_game.NScore(4).ToString();
            m_lblScore5.Text=m_game.NScore(5).ToString();
            m_lblCurPlayer.Text=m_game.GetStatus();
            m_lblNTiles.Text="Tiles to go: "+m_game.NTiles;
        }

        private void m_btnSkip_Click(object sender,EventArgs e) {
            m_game.Skip();
            UpdateText();
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

        private void m_rbNormal_CheckedChanged(object sender,EventArgs e) {
            m_game.SetViewMode(0);
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

        private void m_rbBound_CheckedChanged(object sender,EventArgs e) {
            m_game.SetViewMode(1);
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

        private void m_rbFeatures_CheckedChanged(object sender,EventArgs e) {
            m_game.SetViewMode(2);
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

        private void m_rbFollowers_CheckedChanged(object sender,EventArgs e) {
            m_game.SetViewMode(3);
            glControl1.Invalidate();
            glControl2.Invalidate();
        }

    }
}
